在高版本的.Net中提交post请求提示 asp.net 从客户端中检测到有潜在危险的 Request.Form 值。

在提交表单时候,asp.net 提示:”从客户端(……)中检测到有潜在危险的 Request.Form 值” 。asp.net中的请求验证特性提供了某一等级的保护措施防止XSS攻击,asp.net的请求验证是默认启动的。这个给出各个版本.net的解决方法。

asp.net 2.0 通常解决办法:

方案一:

将.aspx文件中的page项添加ValidateRequest=”false” ,如下:

<%@ Page ValidateRequest=”false” Language=”C#” AutoEventWireup=”true” CodeFile=”test2.aspx.cs” Inherits=”test2″ %>

方案二:

修改web.config配置文件

 <system.web>
<pages validateRequest=”false” >
</pages>
</system.web>

总结:validateRequest 这句我们知道是关闭验证,也就是说提交带标签,比如 <strong>粗体</strong> 这样的值时,ASP.NET 不会报错。这里推荐使用方案一,因为方案一只修改test.aspx这一个页面;而如果使用方案二的话,将是整个解决方案都变成ValidateRequest=”false” 。

asp.net 4.0 解决办法:

4.0和2.0的方法一样,不过要注意的是从 .Net Framework 4.0 开始,asp.net开始强制检测Request参数安全,而我们可以通过修改 Web.config 来恢复 2.0 版本的模式。

方法如下:

修改Web.config,增加requestValidationMode=”2.0″属性值

 <system.web>
<httpRuntime requestValidationMode=”2.0″ />
  <pages validateRequest=”false”></pages>
</system.web>

4.0 中多了一个 requestValidationMode,这是什么意思呢?

requestValidationMode 有两个值:

•2.0仅对网页启用请求验证。是启用还是关闭取决于 validateRequest。

•4.0 默认值。任何 HTTP 请求都会启用请求验证,也就是说不光是网页,还包括 Cookie 等。此时强制启用,不管 validateRequest 为何值。

由于 requestValidationMode=”4.0″ 是强制启用,所以我们会发现在 .NET Framework 4.0 中仅靠设置 validateRequest 是关闭不了请求验证的,还得将 requestValidationMode 设置为 2.0。

发表评论

/ 快捷键:Ctrl+Enter
加载中……